config/routes.rb
Rails.application.routes.draw do
  resources :deployments, as: 'oasis_switchable_deployments', only: [:show, :create, :destroy]
  resources :switchers, as: 'oasis_switchers'
  root 'switchers#index'
end

app/controllers/deployments_controller.rb
class DeploymentsController < ApplicationController
  def create
    respond_to do |format|
      begin
        @deployments = Oasis::SwitchableDeployment.create(**create_deployment_params.to_h.symbolize_keys)
      rescue Oasis::SwitchableDeploymentError => e
        @deployment_creation_error = e.message
        logger.error(@deployment_creation_error)
      rescue Oasis::UnknownSwitchableDeploymentError => e
        @deployment_creation_error = e.message
        logger.error(@deployment_creation_error)
      end
      format.turbo_stream
    end
  end

  def destroy
    respond_to do |format|
      begin
        @deployment = K8sWatcher.instance.find_deployment(params[:id])
        @deployment.destroy
      rescue Oasis::SwitchableDeploymentError => e
        @deployment_creation_error = e.message
        logger.error(@deployment_creation_error)
      rescue Oasis::UnknownSwitchableDeploymentError => e
        @deployment_creation_error = e.message
        logger.error(@deployment_creation_error)
      end
      format.turbo_stream
    end
  end

  private

  def create_deployment_params = params.require(:oasis_switchable_deployment).permit(%i[labels])
end

app/helpers/deployments_helper.rb
module DeploymentsHelper
end

app/views/deployments/_deployment.html.erb
<%= turbo_frame_tag "#{deployment.id}-frame" do %>
    <div
    id="<%= deployment.id %>"
    data-blockly-target="unmanagedDeployment"
    data-deployment=<%= deployment.to_json %>
    >
    <%= deployment.name %>
    <div>
    <%= link_to 'Destroy', oasis_switchable_deployment_path(deployment),
            data: {turbo_method: :delete, turbo_confirm: 'Are you sure?'} %>
<% end -%>

app/views/deployments/_form.html.erb
<%= turbo_frame_tag "new-deployment-form" do %>
  <%= form_with(url: oasis_switchable_deployments_path) do |form| %>
    <div class="field">
      <h3>Deployment Selector</h3>
      <%= form.text_field 'oasis_switchable_deployment[labels]' %>
    </div>
    <div>
      <%= form.submit "Create" %>
    </div>
  <% end -%>
<% end -%>

app/views/deployments/create.turbo_stream.erb
<% if @deployment_creation_error -%>
<%= turbo_stream.replace "deployment_creation_error" do %>
  <p><%= @deployment_creation_error %></p>
<% end -%>
<% else -%>
<%= turbo_stream.append "unmanaged_deployments" do %>
  <% @deployments.each do |md| -%>
    <li id="<%= md.id %>-item">
      <%= render 'deployments/deployment', deployment: md %>
    </li>
  <% end -%>
<% end -%>
<% end -%>
<%= turbo_stream.replace "new-deployment-form" do -%>
  <%= render partial: "deployments/form" %>
<% end -%>

app/views/deployments/destroy.turbo_stream.erb
<% if @deployment_creation_error -%>
<%= turbo_stream.replace "deployment_creation_error" do %>
  <p><%= @deployment_creation_error %></p>
<% end -%>
<% else -%>
<%= turbo_stream.remove "#{@deployment.id}-item" %>
<% end -%>